typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long uint32_t;

sfr at 0x88 TCON;
sfr at 0x89 TMOD;
sfr at 0x8a TL0;
sfr at 0x8c TH0;

sfr at 0x80 IOA;
sfr at 0x90 IOB;
sfr at 0xa0 IOC;
sfr at 0xb0 IOD;
sfr at 0xb1 IOE;

sfr at 0xb2 OEA;
sfr at 0xb3 OEB;
sfr at 0xb4 OEC;
sfr at 0xb5 OED;
sfr at 0xb6 OEE;

sfr at 0xba EP01STAT;
sfr at 0xaa EP2468STAT;

xdata at 0xe600 volatile uint8_t CPUCS;
xdata at 0xe601 volatile uint8_t IFCONFIG;
xdata at 0xe604 volatile uint8_t FIFORESET;
xdata at 0xe60b volatile uint8_t REVCTL;
xdata at 0xe65d volatile uint8_t USBIRQ;
xdata at 0xe680 volatile uint8_t USBCS;

xdata at 0xe68a volatile uint8_t EP0BCH;
xdata at 0xe68b volatile uint8_t EP0BCL;
xdata at 0xe6a0 volatile uint8_t EP0CS;
xdata at 0xe6b8 volatile uint8_t SETUPDAT[8];

xdata at 0xe690 volatile uint8_t EP2BCH;
xdata at 0xe691 volatile uint8_t EP2BCL;
xdata at 0xf000 volatile uint8_t EP2FIFOBUF[1024];

xdata at 0xe694 volatile uint8_t EP4BCH;
xdata at 0xe695 volatile uint8_t EP4BCL;
xdata at 0xf400 volatile uint8_t EP4FIFOBUF[1024];

xdata at 0xe698 volatile uint8_t EP6BCH;
xdata at 0xe699 volatile uint8_t EP6BCL;
xdata at 0xf800 volatile uint8_t EP6FIFOBUF[1024];

xdata at 0xe614 volatile uint8_t EP6CFG;
xdata at 0xe61a volatile uint8_t EP6FIFOCFG;
xdata at 0xe624 volatile uint8_t EP6AUTOINLENH;
xdata at 0xe625 volatile uint8_t EP6AUTOINLENL;
xdata at 0xe655 volatile uint8_t EP6FIFOIRQ;
xdata at 0xe6a5 volatile uint8_t EP6CS;

xdata at 0xe615 volatile uint8_t EP8CFG;
xdata at 0xe61b volatile uint8_t EP8FIFOCFG;
xdata at 0xe626 volatile uint8_t EP8AUTOINLENH;
xdata at 0xe627 volatile uint8_t EP8AUTOINLENL;

xdata at 0xe65f volatile uint8_t EPIRQ;

#define SYNCDELAY   _asm nop nop nop _endasm

int main()
{
    uint16_t n;

    // Let the USB core handle standard requests
    USBCS = 0x00;

    TMOD = 0x31;
    TCON = 0x00;

    IOA = 0x21;

    OEA = 0x33;
    OEB = 0x00;
    OEC = 0x00;
    OED = 0x00;
    OEE = 0x00;
    
    CPUCS = 0x10;
    IFCONFIG = 0x03;
    SYNCDELAY;

    REVCTL = 0x03;
    SYNCDELAY;

    EP6CFG = 0xe0;
    SYNCDELAY;

    // Reset FIFOs
    FIFORESET = 0x80;
    SYNCDELAY;
    FIFORESET = 0x02;
    SYNCDELAY;
    FIFORESET = 0x04;
    SYNCDELAY;
    FIFORESET = 0x06;
    SYNCDELAY;
    FIFORESET = 0x08;
    SYNCDELAY;
    FIFORESET = 0x00;

    EP6FIFOCFG = 0x0d;
    SYNCDELAY;
 
    EP6AUTOINLENH = 0x02;
    SYNCDELAY;
    EP6AUTOINLENL = 0x00;
    SYNCDELAY;

    n = 0;
    while (1)
    {
        if (EP6CS & 8)
        {
//            EP6FIFOIRQ = 1;
            ++n;
            if (n == 16383)
            {
                IOA ^= 1;
                n = 0;
            }
        }
    }
}
